package com.ruoyi.common.pay;

import com.alipay.api.domain.MultiStepTransOrderDetailRequest;
import com.wechat.pay.java.service.transferbatch.model.TransferDetailInput;

import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.List;

/**
 * 可批量转账的接口
 * @author wjh
 * 2024/8/9
 */
public interface BatchTransferAble {

    /**
     * 转账总金额（分）
     */
    Long transferTotalFen();

    /**
     * 转账总金额（元）
     * @return
     */
    default BigDecimal transferTotalYuan() {
        return BigDecimal.valueOf(transferTotalFen()).divide(new BigDecimal(100), 2, RoundingMode.HALF_UP);
    }

    /**
     * 转账外部订单号
     */
    String transferOutBatchNo();

    /**
     * 转账名称
     */
    String transferBatchName();

    /**
     * 转账备注
     */
    String transferBatchRemark();


    /**
     * 微信转账明细
     */
    List<TransferDetailInput> wxTransferDetailList();

    /**
     * 支付宝转账明细
     */
    List<MultiStepTransOrderDetailRequest> aliTransferDetailList();
}
